package cn.hnthyy.thmz.socket;

import lombok.extern.slf4j.Slf4j;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.stereotype.Component;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * 发药实现消息的接收推送
 *
 */
@Slf4j
@ServerEndpoint(value = "/prescriptionPrintSocket/{type}")
@Component
public class PrescriptionPrintSocket {

    /**
     * 记录当前在线连接数
     */
    private static AtomicInteger onlineCount = new AtomicInteger(0);

    /**
     * 存放所有在线的客户端
     */
    private static Map<String, Session> clients = new ConcurrentHashMap<>();

    /**
     * 存放所有在线客户端所属的类型
     */
    private static Map<String, String> clientTypes = new HashMap<>();

    /**
     * 连接建立成功调用的方法
     */
    @OnOpen
    public void onOpen(@PathParam(value = "type") String type, Session session) {
        onlineCount.incrementAndGet(); // 在线数加1
        clients.put(session.getId(), session);
        clientTypes.put(session.getId(), type);
        log.info("有新连接加入：{}，类型：{}，当前在线人数为：{}", session.getId(), type, onlineCount.get());
    }

    /**
     * 连接关闭调用的方法
     */
    @OnClose
    public void onClose(Session session) {
        onlineCount.decrementAndGet(); // 在线数减1
        clients.remove(session.getId());
        clientTypes.remove(session.getId());
        log.info("有一连接关闭：{},类型：{}，当前在线人数为：{}", session.getId(), clientTypes.get(session.getId()), onlineCount.get());
    }

    /**
     * 收到客户端消息后调用的方法
     *
     * @param message 客户端发送过来的消息
     */
    @OnMessage
    public void onMessage(String message, Session session) {
        log.info("服务端收到客户端[{}]的消息:{}", session.getId(), message);
        JSONObject jsonObject = new JSONObject(message);
        JSONArray objJsonTypes = jsonObject.getJSONArray("objTypes");
        List<String> objTypes = new ArrayList();
        for (int i = 0; i < objJsonTypes.length(); i++) {
            objTypes.add((String) objJsonTypes.get(i));
        }
        Map<String,Object> msgMap = new HashMap();
        msgMap.put("patient_id",jsonObject.getString("patient_id"));
        msgMap.put("name",jsonObject.getString("name"));
        msgMap.put("type",jsonObject.getString("type"));
        this.sendMessage(msgMap, objTypes);
    }

    @OnError
    public void onError(Session session, Throwable error) {
        log.error("发生错误");
        error.printStackTrace();
    }

    /**
     * 群发消息
     *
     * @param msgObj   消息内容
     * @param objTypes 接收消息的客户端类型SocketSenderTypeEnum
     * @return 接收消息的客户端数量
     */
    public int sendMessage(Object msgObj, List<String> objTypes) {
        int i = 0;
        for (Map.Entry<String, Session> sessionEntry : clients.entrySet()) {
            Session toSession = sessionEntry.getValue();
            String jsonObject = JSONObject.valueToString(msgObj);
            // 发送消息给接收方
            for (String type : objTypes) {
                if (clientTypes.get(toSession.getId()).equals(type)) {
                    log.info("服务端给客户端[{}]发送消息{}", toSession.getId(), jsonObject);
                    toSession.getAsyncRemote().sendText(jsonObject);
                    i++;
                }
            }
        }
        return i;
    }
}
